/* $Id: dve68k-sci.c,v 1.2 2000/11/11 09:58:20 honda Exp $
 *
 * dve68k-sci.c
 *
 * Modifications for the uITRON4.0 specification OS "TOPPERS" by Shinya Honda
 *
 * This file is subject to the terms and conditions of the GNU Lesser
 * General Public License.  See the file "COPYING.LIB" in the main
 * directory of this archive for more details.
 *
 * Implementation taken from ItIs kernel 
 */


#include "io.h"

/*
 *  MPSCȥ쥸
 */

#define MPSC_RESET	0x18		/* ݡȥꥻåȥޥ */
#define MPSC_EOI	0x38		/* EOI (End of Interrupt) */

#define CR3_DEF		0xc1		/* ǡ 8bit, ֥͡ */
#define CR4_DEF		0x44		/* ȥåץӥå 1bit, ѥƥʤ */
#define CR5_DEF		0xea		/* ǡ 8bit, ֥͡ */
#define BRG2_DEF	0x06		/* 38400bps () */
#define BRG1_DEF	0x00		/* 38400bps () */

#define CR10_DEF	0x00		/* NRZ */
#define CR14_DEF	0x07		/* ܡ졼ȥͥ졼֥͡ */
#define CR15_DEF	0x56		/* ܡ졼ȥͥ졼 */

#define CR1_ALL		0x12		/* ߤ */
#define CR1_RECV	0x10		/* ߤΤߵ */
#define CR1_DOWN	0x00		/* ߤػ */


/*
 *  ꥢݡȤΥϡɥ¸
 */
typedef struct hardware_serial_port_descripter {
	IOREG	*data;		/* ǡ쥸 */
	IOREG	*cntrl;		/* ȥ쥸 */
	byte	cr3_def;	/* ǥեȤ (CR3) */
	byte	cr4_def;	/* ǥեȤ (CR4) */
	byte	cr5_def;	/* ǥեȤ (CR5) */
	byte	brg2_def;	/* ǥեȤ (ܡ졼Ȳ) */
	byte	brg1_def;	/* ǥեȤ (ܡ졼Ⱦ) */
} HWPORT;


const HWPORT p={ MPSC_DATAA,MPSC_CNTRLA,
                 CR3_DEF,CR4_DEF, CR5_DEF, BRG2_DEF, BRG1_DEF };

/*
 * const HWPORT p={MPSC_DATAB, MPSC_CNTRLB,
 *               CR3_DEF, CR4_DEF, CR5_DEF, BRG2_DEF, BRG1_DEF };
 */

/*
 *  ꥢI/OݡȤν
 */
void
sci_init()
{
	/*
	 *  MPSC 
	 */
   	io_write(p.cntrl, MPSC_RESET);
	mpsc_write(MPSC_CNTRLA, MPSC_CR2, 0x18);
	mpsc_write(MPSC_CNTRLB, MPSC_CR2, 0x00);
	mpsc_write(p.cntrl, MPSC_CR1, CR1_RECV);
	mpsc_write(p.cntrl, MPSC_CR4, p.cr4_def);
	mpsc_write_brg(p.cntrl, MPSC_CR12, 0x01, p.brg2_def, p.brg1_def);
	mpsc_write_brg(p.cntrl, MPSC_CR12, 0x02, p.brg2_def, p.brg1_def);
	mpsc_write(p.cntrl, MPSC_CR15, CR15_DEF);
	mpsc_write(p.cntrl, MPSC_CR14, CR14_DEF);
	mpsc_write(p.cntrl, MPSC_CR10, CR10_DEF);
	mpsc_write(p.cntrl, MPSC_CR3, p.cr3_def);
	mpsc_write(p.cntrl, MPSC_CR5, p.cr5_def);

}


Inline int
getDebugCharReady(void)
{
    return((mpsc_read(p.cntrl, MPSC_SR0) & 0x01) != 0);
}

byte
getDebugChar(void)
{
    while(!getDebugCharReady());
    return(io_read(p.data));
}



Inline int
putDebugCharReady(void)
{
	return((mpsc_read(p.cntrl, MPSC_SR0) & 0x04) != 0);
}


/*
 *  ʸν񤭹
 */
void
putDebugChar(byte ch)
{
    while(!putDebugCharReady());
    io_write(p.data, ch);
}

